#include <iostream>
#include <cmath>

#include "crystal.h"
using namespace std;



//==================================Constructeurs, destructeur====================================

Crystal::Crystal(int C_orient, int IS, double C_xmax, double C_ymax, double Cry_length, double Rcurv)
    : miscut(miscut), Rcurv(Rcurv), Cry_length(Cry_length), C_xmax(C_xmax), C_ymax(C_ymax), Alayer(Alayer), IS(IS), C_orient(C_orient), ZN(ZN), NAM(NAM)
{

    //Some usefull parameters !!

    Alayer = 0;

    cry_bend = (Cry_length / Rcurv); //total bending for this crystal;
    s_length = Rcurv * (sin(cry_bend));
    xmax = C_xmax ;
    L_chan = Cry_length; //Careful : the channeling length is the length of the particle trajectory, not the long. one
    tchan = cry_bend;
    ymin = -C_ymax / 2 ;
    ymax =  C_ymax / 2;

    ZN = 1;
    NAM = 1;
    miscut = 0;

    DLAI[0] = 1.6;
    DLAI[1] = 0.57;
    DLAI[2] = 2.2;
    DLAI[3] = 1.0;
    SAI[0] = 42.0;
    SAI[1] = 140.0;
    SAI[2] = 42.0;
    SAI[3] = 50.0;
    DLRI[0] = 0.09336;
    DLRI[1] = 0.0035;
    DLRI[2] = 0.188;
    DLRI[3] = 0.023;
    DLYI[0] = 0.455;
    DLYI[1] = 0.096;
    DLYI[2] = 0.400;
    DLYI[3] = 0.162;
    AI[0] = 0.96e-7;
    AI[1] = 0.56e-7;
    AI[2] = 0.63e-7;
    AI[3] = 1.0e-7;
    DES[0] = 0.56;
    DES[1] = 3.0;
    DES[2] = 0.6;
    DES[3] = 1.0;
    eUm[0] = 21.34;
    eUm[1] = 21.0;
    eUm[2] = 21.0;
    eUm[3] = 21.0;

}

/*
void Crystal::afficheCrystal(){

 cout << "Here is the implicit parameters : " <<endl;
 cout << "L_chan:" << L_chan << endl;
 cout << "tchan:" << tchan << endl;

}
*/

