#include <iostream>
#include <cmath>

using namespace std;
/*This class describes the crystal in the experiment. It has as attribute the 6-dimensional coordinates and as methods some usefull tools related to the the geometric
 */


class Crystal
{

public:

    //==================Constructeurs, destructeur=========================================

    Crystal(int C_orient, int IS, double C_xmax, double C_ymax, double Cry_length, double Rcurv);


    ~Crystal() {};



    //private:

    /* Other parameters that depend on the inital one and it will simplify or calculation*/

    double cry_bend;   //total bending for this crystal
    double s_length;   // length in longitudinal axe
    double xmax;       // Parameter of the crystal [m]
    double ymax;       // Parameter of the crystal [m]
    double ymin;       // Parameter of the crystal [m]
    double L_chan;
    double tchan;      //Channeling angle
    double miscut;     //miscut angle [rad]
    double Rcurv;      //curvature radius [m]
    double Cry_length; //crystal length [m]
    double C_xmax;     // maximum in x direction (dim of crystal) [m]
    double C_ymax;     //maximum in y direction (dim of crystal) [m]
    double Alayer;     //amourphous layer dimension [m]
    int IS;            // Interger that defined the substances !!!! Warning !!! 0 -> Si :::  1 -> W  :::  2 -> C  :::  3-> Ge
    int C_orient;   // Crystal orientation !! = 1 for (110) ; = 2 for (111)
    int ZN;            // MCS parameter, ZN=0 -> no culomb scattering
    int NAM;           //  parameter of nuclei interaction



    //Critical parameter...........

    double xpcrit0; // !critical angle for straight crystal [mrad]
    double Rcrit;   //!critical curvature radius [m]
    double ratio;   //!x=Rcurv/Rcrit
    double xpcrit;  //!critical angle for curved crystal [mrad]

    // -----4 substances: Si(110),W(110),C,Ge------------- Here is some usfull parameter !!!!

    double DLAI[4];    // elastic length [m]
    double SAI[4];     //elastic scat. r.m.s [mr]
    double DLRI[4];    //radiation  length [m]
    double DLYI[4];    //nuclear length [m]
    double AI[4];      // Si(110) 1/2 distance between planes(mm)
    double DES[4];     //energy deposition in subst(GeV/m)
    double eUm[4];     //only for Si(110) potent. [eV]     !maximum potential



    /*double DLAI[4]={1.6,0.57,2.2,1.0};                // elastic length [m]
    double SAI[4]={42.0,140.0,42.0,50.0};             //elastic scat. r.m.s [mr]
    double DLRI[4]={0.09336,.0035,0.188,.023};        //radiation  length [m]
    double DLYI[4]={0.455, 0.096, 0.400, 0.162};      //nuclear length [m]
    double AI[4]={0.96e-7, 0.56e-7, 0.63e-7, 1.0e-7}; // Si(110) 1/2 distance between planes(mm)
    double DES[4]={0.56,  3.0,  0.6, 1.0};            //energy deposition in subst(GeV/m)
    double eUm[4]={21.34,  21.0,   21.0,   21.0};     //only for Si(110) potent. [eV]     !maximum potential
    */

    /*
    void afficheCrystal();
    */
};
